/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.mdr.persistence.jdbcimpl;

import org.netbeans.mdr.persistence.*;

import java.util.*;

/**
 * JdbcCollection is a read-only Collection backed by queries.
 *
 * @author John V. Sichi
 * @version $Id: JdbcCollection.java,v 1.1 2004/02/04 06:38:11 mmatula Exp $
 */
class JdbcCollection extends AbstractCollection
{
    // delegate to JdbcSet for everything
    private JdbcSet set;

    JdbcCollection(
        JdbcStorage storage,
        Storage.EntryType entryType,
        LazyPreparedStatement sqlIterator,
        LazyPreparedStatement sqlSize,
        LazyPreparedStatement sqlContains)
    {
        set = new JdbcSet(storage,entryType,sqlIterator,sqlSize,sqlContains);
    }

    // override AbstractSet
    public boolean contains(Object obj)
    {
        return set.contains(obj);
    }
    
    // implement AbstractCollection
    public Iterator iterator()
    {
        return set.iterator();
    }

    // implement AbstractCollection
    public int size()
    {
        return set.size();
    }
}

// End JdbcCollection.java
