/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.mdr.persistence.jdbcimpl;

import java.sql.*;

/**
 * LazyPreparedStatement is a wrapper for a JDBC PreparedStatement
 * which can be prepared on demand.
 *
 * @author John V. Sichi
 * @version $Id: LazyPreparedStatement.java,v 1.1 2004/02/04 06:38:15 mmatula Exp $
 */
class LazyPreparedStatement
{
    final String sql;
    PreparedStatement ps;

    public LazyPreparedStatement(String sql)
    {
        this.sql = sql;
    }
}

// End LazyPreparedStatement.java
