/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2003 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.mdrant;

import java.io.File;
import java.io.FileOutputStream;

import javax.jmi.reflect.*;

import org.apache.tools.ant.BuildException;
import org.netbeans.api.mdr.DTDProducer;

/** Produces XMI DTD for given metamodel.
 *
 * @author  Petr Hrebejk
 */
public class WriteDTD extends MdrTask.Sub {
    
    // File to write in
    private File file; 
    
    // Extent containing the metamodel
    private String extent;     
       
    public WriteDTD() {
    }
    
    public void execute() throws Exception {
        
        if ( file == null ) {
            throw new BuildException( "Export file has to be sppecified. Use the \"file\" attribute" );
        }
        
        if ( extent == null ) {
            throw new BuildException( "Extent to export has to be sppecified. Use the \"extent\" attribute" );
        }
        
        DTDProducer.getDefault().generate( new FileOutputStream( file ), getRepository().getExtent( extent ) );
        
    }
    
    // ANT task attributes -----------------------------------------------------
    
    public void setFile( File file ) {
        this.file = file;
    }
    
    public void setExtent( String extent ) {
        this.extent = extent;
    }
    
    
}
