/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.lib.jmi.query;

import java.util.Collection;
import java.util.Iterator;


/** This is the main interface. For read only results sets.
 *
 * @author Petr Hrebejk
 */
public interface Query {

    /** Returns all elements in the iterator 
    * @return Iterator with all elements
    */
    public Iterator iterator();

    /** Tests wether the object is contained in the Query
    * @param object Object to find
    * @return true if the mofid is contained in the Query
    */
    public boolean contains( Object object );    
    
}
