/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2002 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.lib.jmi.xmi;

import org.netbeans.api.xmi.*;

public class InputConfig extends XMIInputConfig {
    
    private XMIReferenceResolver resolver = null;
    private XMIHeaderConsumer headerConsumer = null;
    private UnknownElementsListener unknownElemsListener = null;
    private boolean ignoreUnknownElements = false;
    
    public void setReferenceResolver(XMIReferenceResolver resolver) {
        this.resolver = resolver;
    }
        
    public XMIReferenceResolver getReferenceResolver() {
        return resolver;
    }
    
    // XMIHeaderConsumer ........................................................
    
    public void setHeaderConsumer(XMIHeaderConsumer consumer) {
        headerConsumer = consumer;
    }
        
    public XMIHeaderConsumer getHeaderConsumer() {
        return headerConsumer;
    }
    
    // ..........................................................................
    
    public boolean isUnknownElementsIgnored() {
        return ignoreUnknownElements;
    }
    
    public void setUnknownElementsIgnored(boolean newValue) {
        ignoreUnknownElements = newValue;
    }
    
    public UnknownElementsListener getUnknownElementsListener() {
        return unknownElemsListener;
    }
    
    public void setUnknownElementsListener(UnknownElementsListener listener) {
        unknownElemsListener = listener;
    }
    
}
