/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2004 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.mdr;

import javax.swing.SwingUtilities;
import org.openide.LifecycleManager;

/**
 *
 * @author  Jan Becicka
 */
public class ShutDownProgressListener {
    
    private ShutDownProgressPanel progressPanel = ShutDownProgressPanel.getDefault();
    
    public void start(final int count) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                progressPanel.setVisible(true);
                progressPanel.progress.setMaximum(count);
            }
        });
    }
    
    public void step() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                progressPanel.progress.setValue(progressPanel.progress.getValue() + 1);
            }
        });
    }
    
    public void stop() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                progressPanel.progress.setValue(progressPanel.progress.getMaximum());
                progressPanel.setVisible(false);
            }
        });
    }
}
