/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2004 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.mdr;

import javax.swing.JDialog;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;
import org.openide.windows.WindowManager;

/**
 *
 * @author  Jan Becicka
 */
public class ShutDownProgressPanel extends JDialog {
    
    private static ShutDownProgressPanel instance = null;
    /** Creates new form UndoProgressPanel */
    private ShutDownProgressPanel() {
        //super(WindowManager.getDefault().getMainWindow(),true);
        setModal(true);
        initComponents();
        pack();
        setBounds(Utilities.findCenterBounds(getSize()));
        //setLocationRelativeTo(WindowManager.getDefault().getMainWindow());
        setTitle(NbBundle.getMessage(ShutDownProgressPanel.class, "LBL_ShutDownTitle"));
    }
    
    public static synchronized ShutDownProgressPanel getDefault() {
        if (instance == null) {
            instance = new ShutDownProgressPanel();
        }
        return instance;
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        progress = new javax.swing.JProgressBar();
        undoLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(12, 12, 11, 11)));
        jPanel1.add(progress, java.awt.BorderLayout.CENTER);

        undoLabel.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/mdr/Bundle").getString("LBL_ShutDownProgressLabel"));
        undoLabel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 1, 6, 1)));
        jPanel1.add(undoLabel, java.awt.BorderLayout.NORTH);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    javax.swing.JProgressBar progress;
    private javax.swing.JLabel undoLabel;
    // End of variables declaration//GEN-END:variables
    
}
