/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is Forte for Java, Community Edition. The Initial
 * Developer of the Original Code is Sun Microsystems, Inc. Portions
 * Copyright 1997-2002 Sun Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.mdrxml.looks;

import java.util.Collection;
import java.util.Iterator;
import org.openide.nodes.*;
import org.openide.util.NbBundle;
import org.netbeans.api.looks.*;
import org.netbeans.spi.looks.*;
import org.netbeans.api.mdr.*;
import xmlmodel.RootNode;
/**
 *
 * @author  Tomas Zezula
 */
public class RootNodeLook extends ElementNodeLook {
    
    private static final String ICON = "org/netbeans/modules/mdrxml/resources/rootNode";
    
    private static class DocumentNameProperty extends PropertySupport.ReadOnly {
        
        private RootNode node;
        
        public DocumentNameProperty (RootNode node) {
            super (NbBundle.getMessage(RootNodeLook.class,"TXT_DocumentName"),String.class,NbBundle.getMessage(RootNodeLook.class,"TXT_DocumentName"),NbBundle.getMessage(RootNodeLook.class,"TIP_DocumentName"));
            this.node = node;
        }
        
        public Object getValue () {
            if (this.node != null)
                return this.node.getDocumentName ();
            else
                return null;
        }
    }
    
    /** Creates a new instance of RootNodeLook */
    public RootNodeLook() {
        super (NbBundle.getMessage (RootNodeLook.class, "TXT_RootNodeLook"));
    }
    
    public String iconBase (Look.NodeSubstitute substitute) {
        return ICON;
    }
    
    public Node.PropertySet[] getPropertySets (Look.NodeSubstitute substitute) {
        Node.PropertySet[] sets = super.getPropertySets (substitute);
        ((Sheet.Set)sets[0]).put (new DocumentNameProperty ((RootNode)substitute.getRepresentedObject()));
        return sets;
    }
    
}
