/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is Forte for Java, Community Edition. The Initial
 * Developer of the Original Code is Sun Microsystems, Inc. Portions
 * Copyright 1997-2002 Sun Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.mdrxml.looks;

import org.openide.util.NbBundle;
import org.netbeans.api.looks.*;
import org.netbeans.spi.looks.*;
/**
 *
 * @author  Tomas Zezula
 */
public class XMLNamespaceLook extends NamespaceLook {
    
    public static final String PREFIX = "Looks/XMLModel/";
    
    /** Creates a new instance of XMLNamespaceLook */
    public XMLNamespaceLook() {
        super (PREFIX);
    }
    
    public Look[] availableLooks (Look.NodeSubstitute substitute) {
        return null;
    }
    
    /** The human presentable name of the look.
     * @return human presentable name
     */
    public String getDisplayName() {
        return this.getName ();
    }
    
    /** Returns name of the look. This name should identify the look.
     * @return Name of the look.
     */
    public String getName() {
        return NbBundle.getMessage (XMLNamespaceLook.class, "TXT_XMLModelView");
    }
    
}
