/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is Forte for Java, Community Edition. The Initial
 * Developer of the Original Code is Sun Microsystems, Inc. Portions
 * Copyright 1997-2002 Sun Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.mdrxml.util;

/**
 *
 * @author  Tomas Zezula
 */
import javax.jmi.reflect.RefBaseObject;
import org.netbeans.api.looks.*;
import org.netbeans.spi.looks.*;

public class NodeEventTranslator extends EventTranslator {
    
    private XMLModelEventTranslator translator;
    private RefBaseObject key;
    
    /** Creates a new instance of NodeEventTranslator */
    public NodeEventTranslator (XMLModelEventTranslator translator, RefBaseObject key, Look.NodeSubstitute substitute) {
        super (substitute);
        this.translator = translator;
        this.key = key;
        this.translator.addNodeSubstitute (key,this);
    }
    
    /** This method is called when the node was garbage collected. You shoud
     * unregister from all objects where this object was registered as a
     * listener.
     */
    protected void unregister() {
        this.translator.removeNodeSubstitute (this.key,this);
    }    
    
    
}
