/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2002 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.mdr.persistence;

/**
 * Interface used for resolving external links (accross storages).
 * @author Daniel Prusa, Tomas Zezula
 */
public interface ObjectResolver {

    /** Resolves object specified by storage id and key.
     * @param storageID related storage uuid
     * @param key
     * @return resolved object
     */
    public Object resolve(String storageID, Object key) throws StorageException;

}
