/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.mdr.persistence;

/**
* StorageClient is implemented by objects stored in the MDR which
* themselves access the MDR.  When the MDR instantiates such an object,
* it calls setStorage on it, passing it the Storage implementation which
* created it
*/
public interface StorageClient {

    /**
    * Pass the object the Storage implementation.  The object can use this
    * to fetch other objects from the MDR.
    * @param storage the Stroage implementation which 
    * instantiated the object
    */
    void setStorage(Storage storage);
}
		
