/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.mdr.persistence.btreeimpl.btreeindex;

import org.netbeans.mdr.persistence.*;
import java.util.*;

public class BtreeListByKeyRepos extends AbstractSequentialList {

    private BtreeListByKey innerList;
    private SinglevaluedIndex repos;
    
    BtreeListByKeyRepos(BtreeListByKey innerList, SinglevaluedIndex repos) {
        this.innerList = innerList;
        this.repos = repos;
    }
    
    public int size() {
        return innerList.size ();
    }
    
    public boolean isEmpty() {
        return innerList.isEmpty();
    }
    
    public boolean add(Object o) {
        ListIterator it = listIterator();
        while (it.hasNext()) it.next();
        it.add(o);
        return true;
    }
    
    public boolean addAll(Collection c) {
        ListIterator it = listIterator();
        while (it.hasNext()) it.next();
        boolean result = false;
        for (Iterator cit = c.iterator(); cit.hasNext();) {
            try {
                it.add(cit.next());
                result = true;
            } catch (RuntimeStorageException e) {
            }
        }
        return result;
    }

    public ListIterator listIterator(int index) {
        return innerList.listIterator (index, repos);
    }

}
