/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2004 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.mdr.persistence.btreeimpl.btreeindex;

/**
 * Represents the location of an entry in a Btree.
 */
final class SearchResult extends Object {

    boolean 	matched;	/* was it an exact match */
    int		entryNum;	/* entry # on the page */
    BtreePage	page;		/* page on which entry was found */
    int		skipCount;	/* For non-unique keys, how many sibling
    				 * pages were traversed to reach this entry
				 */

    SearchResult(boolean matched, int entryNum, BtreePage page) {
	this.matched = matched;
	this.entryNum = entryNum;
	this.page = page;
    }

    SearchResult(SearchResult source) {
	this.matched = source.matched;
	this.entryNum = source.entryNum;
	this.page = source.page;
    }

    void copy(SearchResult target) {
	target.matched = matched;
	target.entryNum = entryNum;
	target.page = page;
	target.skipCount = skipCount;
    }
}
