/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.mdr.util;

import java.util.Map;

public class MapEntryImpl implements Map.Entry {

    private Object key;
    private Object value;
    
    public MapEntryImpl(Object key, Object value) {
        this.key = key;
        this.value = value;        
    }

    public Object getValue () {
        return value;
    }
    
    public Object getKey () {
        return key;
    }

    public Object setValue (Object value) {
        throw new UnsupportedOperationException ();
    }
    
    public boolean equals (Object o) {
        if (o instanceof Map.Entry) {
            Map.Entry e = (Map.Entry) o;
            return (key == null ? e.getKey() == null : e.getKey().equals(key))  &&
                (value == null ? e.getValue() == null : e.getValue().equals(value));
 
        } else {
            return false;
        }
    }

    public int hashCode () {
        return (key == null ? 0 : key.hashCode()) ^ (value == null ? 0 : value.hashCode()); 
    }
    
}
